package CH.ifa.draw.framework;

public interface DrawingContext {
    /**
     * Method that returns if a figure is highlighted.
     * @param figure the current figure
     * @return whether the figure is highlighted or not
     */
    public boolean isHighlighted(Figure figure);

    /**
     * Method that returns if a figure is visible.
     * @param figure the current figure
     * @return whether the figure is visible or not
     */
    public boolean isVisible(Figure figure);

    /**
     * Method to expand macros.
     * @param text the macro to be expanded
     * @return the expanded macro
     */
    public String expandMacro(String text);
}