package CH.ifa.draw.framework;

import java.util.Set;

import javax.swing.*;


/**
 * A container holding toolbuttons whose tools can manipulate the data of a {@link Drawing}.
 */
public interface Toolbar {

    /**
     * The same as {@link #addTools(Set, String, String)}, but the name is also used as the description.
     */
    void addTools(Set<AbstractButton> buttons, String name);

    /**
     * Add a set of toolbuttons to the contained toolbar.
     * @param buttons A set of tool buttons.
     * @param name The name of the toolbutton set, should be unique.
     * @param description A short description of the tools' purpose.
     */
    void addTools(Set<AbstractButton> buttons, String name, String description);

    /**
     * Remove the set of toolbuttons identified by the given String.
     * @param name The name of the toolbutton set to be removed.
     */
    void removeTools(String name);
}
