/**
 *
 */
package CH.ifa.draw.util;

import CH.ifa.draw.framework.Drawing;
import de.renew.util.ObjectInputStreamUsingBottomLoader;

import java.io.*;


/**
 * This class contains utility methods for convenience handling of <code>Drawing</code>.
 *
 * @author cabac
 *
 */
public class DrawingHelper {

    /** Clones the drawing.
     *
     * @param originalDrawing
     * @return a deep clone of the original drawing
     * @throws Exception
     */
    public static Drawing cloneDrawing(Drawing originalDrawing)
                    throws Exception {
        Drawing drawing;
        try {
            ByteArrayOutputStream baos = new ByteArrayOutputStream();
            ObjectOutputStream oos = new ObjectOutputStream(baos);
            oos.writeObject(originalDrawing);
            ByteArrayInputStream bais = new ByteArrayInputStream(
                            baos.toByteArray());
            ObjectInputStream ois = new ObjectInputStreamUsingBottomLoader(bais);
            Object deserializedObject = ois.readObject();
            drawing = (Drawing) deserializedObject;
        } catch (Exception e) {
            e.printStackTrace();
            throw new Exception("Could not clone drawing: "
                            + originalDrawing.getName(), e);
        }
        return drawing;
    }
}