
package de.renew.diagram;


/**
 * ActionTextFigure
 * @author cabac
 *
 */
public class ActionTextFigure extends DiagramTextFigure {
    private static final String ACTION = "action";

    /**
     *	Default constructor of an ActionTextFigure object, containing the text "Action"
     */
    public ActionTextFigure() {
        super();
        setAlternateText(ACTION);
    }

    /**
     * @param canBeConnected boolean whether the ActionTextFigure can be connected.
     */
    public ActionTextFigure(boolean canBeConnected) {
        super(canBeConnected);
        setAlternateText(ACTION);
    }

    /**
     * @param text string that contains the displayed text
     */
    public ActionTextFigure(String text) {
        super(text);
        setAlternateText(ACTION);
    }

    /**
     * @param text string that contains the displayed text
     * @param isReadOnly boolean whether the text is only readable
     */
    public ActionTextFigure(String text, boolean isReadOnly) {
        super(text, isReadOnly);
        setAlternateText(ACTION);
    }
}
