<!-- Adapted from: https://www.writethedocs.org/guide/writing/beginners-guide-to-docs/ -->

# Extras

## User Guide

_Extras_ adds some additional and experimental features to Renew.

### Features

- Adjust the layout of Java reference nets
- Export the viewport to various formats

### Example Usage

1. Open a net of type Java reference net in the graphical editor.
2. Select the Layout Window via Layout -> Layout Window.
3. Adjust the layout by selecting elements in the graphical editor and utilizing the buttons in the Layout Window.

### Provided Commands

<!-- Use the classes implementing CLCommand. The 'help' output of the command can be a useful description -->

- `copystyle` - copy the style from the selected figure
- `applystyle`- applies the copied style to the selected figures
- `attr` - inspects and sets attributes of selected figure  
  Usage:
    1. attr    -  display all attributes  
    2. attr name   - display attribute `name`
    3. attr name value - set attribute `name` to `value`. Use NULL to remove attribute, TRUE or FALSE to set a boolean value. You will need to save the drawing to persist the attributes.
- `labels` - will add labels to all nodes, which have no labels yet, in a Petri nets
- `renameconcept` - converts all ontology concept names from camel-case (ConceptName) to spinal-case (concept-name)
- `reload` - reloads the plugin with the given name  
  (If the argument "-v" is given, verbose output is printed, especially concerning load errors regarding dependency problems)
- `organize` - reorganizes the statements of a declaration node
- `sd` - displays and manipulates (the exact) dimensions of a selected figure
- `!` - passes the execution to the shell
- `sim` - provides information about the current simulation state
- `import` - imports a file into a drawing

### Installation

Install _Extras_ by putting the JAR file inside the `dist/plugins` directory.

It will be automatically loaded at startup of Renew.

### Dependencies

This plugin depends on the following plugins and external libraries:

<!-- must match the `module-info.java` -->

- `Gui`: Add new options to the menu
- `FS`: Supports modelling processes and the creation of ontologies
- `Export`: Allows export of the viewport to various formats


### Configuration

During the initialization of _Extras_, the following properties are read from the `renew.properties` file in the Renew root directory.

**NAME**|**TYPE**|**DESCRIPTION**|**DEFAULT**
:-----|:-----:|:-----|:-----
`de.renew.extras.incremental-eps-export`|`boolean`|If true incremental filename extension is usable.|false
`de.renew.extras.eps-viewport-export`|`boolean`|If true eps viewport export format is usable.|false
`de.renew.extras.layoutwindow.enable`|`boolean`|If true Layout Window Menu Entry is added.|true

## Developer Guide

### Core Classes

- `ExtrasPlugin`: Extends the `PluginAdapter` to manage the startup and shutdown.
- `LayoutWindow`: Contains most logic of the layout window.
- `TextExportFormat`: Adds functionality for exporting Java reference nets to .txt files.
- `EPSViewportExportFormat`: Adds functionality for exporting Java reference nets to .eps files.

### How to Extend

_Extras_ is not meant to be extended.

<!-- ### Additional Information -->

<!-- Common issues, explanations for inconsistencies, etc. -->

<!-- Contribution Info -->

<!-- License -->
