/**
 *
 */
package de.renew.extras.exports;

import java.io.File;
import java.io.FilenameFilter;


/**
 * @author roelke
 *
 * Filter for eps-files with _exact_ matching of filename prefixes.
 */
public class PrefixEPSFileFilter implements FilenameFilter {
    private String filePrefix = new String();

    public PrefixEPSFileFilter(String prefix) {
        filePrefix = prefix;
    }

    /**
     * @see java.io.FilenameFilter#accept(java.io.File, java.lang.String)
     *
     * Filter for eps-files with _exact_ matching of filename prefixes.
     */
    @Override
    public boolean accept(File dir, String fileName) {
        return (fileName.startsWith(filePrefix) && (fileName.endsWith("eps")
                        || fileName.endsWith("EPS")));
    }
}