
<!-- Adapted from: https://www.writethedocs.org/guide/writing/beginners-guide-to-docs/ -->

# FAFormalism

## User Guide

The plugin allows for simulating finite automata models that have been drawn with the FA plugin.

### Features

- Simulate a finite automata model that has been drawn with the FA plugin
- Visualize the simulation

### Example Usage

To create a new FA model:

1. Open the GUI
2. Create a new file of the type `.fa` (File -> New Drawing)
3. Tools -> FA Drawing Tool -> FA Drawing Tools
4. Use the new tools that became available to create a FA model

Simulate the FA model:

1. Simulation -> Formalisms -> Select the FA compiler
2. Run the simulation with Simulation -> Run Simulation(Ctrl+R) / Simulations Step (Ctrl+I)

A more detailed user guide (both English and German version) for the usage can be found in the doc-folder.

### Provided Commands

<!-- Use the classes implementing CLCommand. The 'help' output of the command can be a useful description -->

No commands are provided.

### Installation

Install _FAFormalism_ by putting the JAR file inside the `dist/plugins` directory.

It will be automatically loaded at startup of Renew.
### Dependencies

This plugin depends on the following plugins and external libraries:

<!-- must match the `module-info.java` -->

- `Formalism` - Provides support for the net compiler
- `log4j`: Logging Framework

### Configuration

FAFormalism does not offer configuration options.

## Developer Guide

### Core Classes

- `FANetCompiler`: Compiles a single FA-net for simulation.
- `FAFormalismPlugin`: Wrapper-class for the FAFormalism Plugin. It extends `Plugin Adapter` to manage the startup and shutdown.

### How to Extend

_FAFormalism_ doesn't expose any interfaces.

### Additional Information

<!-- Common issues, explanations for inconsistencies, etc. -->

None.

<!-- Contribution Info -->

<!-- License -->