package de.renew.gui;

import CH.ifa.draw.framework.DrawingEditor;
import CH.ifa.draw.framework.DrawingView;
import CH.ifa.draw.standard.AbstractTool;
import CH.ifa.draw.standard.StandardDrawingView;

/**
 * Creates an AbstractZoomTool needed for the zoom buttons.
 */
public abstract class AbstractZoomTool extends AbstractTool {
    protected AbstractZoomTool(DrawingEditor editor) {
        super(editor);
    }

    protected StandardDrawingView getCurrentStandardDrawingView() {
        final GuiPlugin guiPlugin = GuiPlugin.getCurrent();
        if (guiPlugin != null && guiPlugin.getDrawingEditor() != null) {
            final DrawingView view = guiPlugin.getDrawingEditor().view();
            if (view instanceof StandardDrawingView) {
                return (StandardDrawingView) view;
            }
        }
        return null;
    }
}
