package de.renew.gui;

import CH.ifa.draw.framework.DrawingEditor;
import CH.ifa.draw.standard.StandardDrawingView;

import javax.swing.JViewport;
import java.awt.Point;



/**
 * Resets the zoom factor.
 */
public class ZoomResetTool extends AbstractZoomTool {

    public ZoomResetTool(DrawingEditor editor) {
        super(editor);
    }

    @Override public void activate() {
        super.activate();
        final GuiPlugin guiPlugin = GuiPlugin.getCurrent();
        if (guiPlugin != null && guiPlugin.getDrawingEditor() != null) {
            resetZoom();
        }
        super.deactivate();
    }

    private void resetZoom() {
        StandardDrawingView standardDrawingView = getCurrentStandardDrawingView();
        if (standardDrawingView != null) {
            JViewport viewport = (JViewport) standardDrawingView.getParent();
            Point center = new Point(viewport.getWidth() / 2,
                            viewport.getHeight() / 2);
            standardDrawingView.zoomOnPoint(1, center);
        }

    }
}