package de.renew.plugin;

import java.util.Collection;


/**
 * This Exception is thrown by the DependencyCheckList if a
 * dependency relation is broken.
 *
 * @author J&ouml;rn Schumacher &amp; Hamed M.
 * @version 30.11.2020
 */
public class DependencyNotFulfilledException extends Exception {
    private Collection<?> _elements;

    public DependencyNotFulfilledException() {
        super();
    }

    /**
     * This is a constructor for the DepencencyNotFulfilledException. 
     * The exception checks whether a dependency is being fullfilled, if it is not the case then 
     * an error message is being displayed. 
     * @param message An String is being put in on DependencyNotFulfilledException
     */
    public DependencyNotFulfilledException(String message) {
        super(message);
    }

    /**
     * This is a constructor for DependencyNotFulfilledException also. The Exception checks whether a dependency is being fullfilled,
     * if it is not the case then 
     * an error message is being displayed. Additionally the Exception can contain elements in contrast
     * to the other overloaded method with same name.
     * @param message An String is being put in on DependencyNotFulfilledException
     * @param elements of Type Collection as parameters to have excepted elements
     */
    public DependencyNotFulfilledException(String message,
                                           Collection<?> elements) {
        super(message);
        this._elements = elements;
    }

    /**
     * This method returns the contained elements of a given Collection as a getter Method. 
     * @return _elements  An Element is being returned
     */
    public Collection<?> getElements() {
        return _elements;
    }
}
