package de.renew.plugin.load;

import java.util.List;

public class ModuleLayerByNameException extends RuntimeException{

    /**
     * Creates the exception for the case if the module layer is not found by Name.
     * @param moduleLayerNames The names of module layer that are not found.
     * @author Laif-Oke Clasen
     */
    public ModuleLayerByNameException(List<String> moduleLayerNames)
    {
        super(buildMessage(moduleLayerNames));
    }

    /**
     * Creates the exception message for the case if the module layer is not found by Name.
     * @param moduleLayerNames The names of module layer that are not found.
     * @return The exception Message
     * @author Laif-Oke Clasen
     */
    private static String buildMessage(List<String> moduleLayerNames)
    {
        StringBuilder Msg = new StringBuilder("ModuleLayerByNameException: Module layer ");
        for(int i = 0; i < moduleLayerNames.size();i++)
        {
            Msg.append(moduleLayerNames.get(i));
            if(i != moduleLayerNames.size()-1 && i != moduleLayerNames.size()-2)
            {
                Msg.append(" , ");
            }
            if(i == moduleLayerNames.size()-2)
            {
                Msg.append(" and ");
            }
        }
        Msg.append(" not found.");
        return Msg.toString();
    }
}
