package de.renew.formalism.stub;

import de.renew.call.SynchronisationRequest;
import de.renew.formalism.function.AbstractMethodFunction;
import de.renew.net.NetInstance;
import de.renew.unify.Tuple;


public class ChannelMethodFunction extends AbstractMethodFunction {
    private String startChannel;
    private String resultChannel;

    public ChannelMethodFunction(String startChannel, String resultChannel) {
        this.startChannel = startChannel;
        this.resultChannel = resultChannel;
    }

    public ChannelMethodFunction(String name) {
        this(name, "_" + name);
    }

    @Override
    public Object doFunction(Object obj, Object[] paramArr) throws Exception {
        SynchronisationRequest.synchronize((NetInstance) obj, startChannel,
                        new Tuple(paramArr, null));

        Tuple outTuple = SynchronisationRequest.synchronize((NetInstance) obj,
                        resultChannel, new Tuple(1));
        return outTuple.getComponent(0);
    }
}