package de.renew.ontology;

import de.renew.ontology.entities.Ontology;
import de.renew.ontology.exception.OntologyGeneratorException;

import java.io.File;


/**
 * @author Konstantin Simon Maria Moellers
 * @version 2015-01-14
 */
public interface OntologyGenerator {

    /**
     * Generates the ontology from a given ontology model.
     *
     * @param ontology the model to generate from.
     */
    public void generate(Ontology ontology) throws OntologyGeneratorException;

    /**
     * Returns a name string representing this generator.
     *
     * @return string representing the name.
     */
    public String getGeneratorName();

    /**
     * Sets the directory where the artifacts get generated to.
     */
    public void setDestinationDirectory(File destinationDirectory);

    /**
     * @return directory where the artifacts get generated to.
     */
    public File getDestinationDirectory();
}