package de.renew.rgbase.elements;

/**
 * An {@link Edge} that can be inscribed with text.
 *
 * @author Michael Simon
 */
public class InscribedEdge extends Edge {
    private final String name;
    private final String description;

    public InscribedEdge(String name, String description, Node targetNode) {
        super(targetNode);
        this.name = name;
        this.description = description;
    }

    public String getName() {
        return name;
    }

    public String getDescription() {
        return description;
    }
}