package de.renew.net.arc;

import de.renew.net.SimulatablePlaceInstance;
import de.renew.net.TokenReserver;

import de.renew.unify.Variable;


public class TestArcBinder extends ArcRemoveBinder {
    protected TestArcBinder(Variable variable,
                            SimulatablePlaceInstance placeInstance) {
        super(variable, placeInstance);
    }

    @Override
    protected boolean mayBind() {
        return true;
    }

    @Override
    protected boolean possible(TokenReserver reserver, Object token) {
        return reserver.containsTestableToken(placeInstance, token);
    }

    @Override
    protected boolean remove(TokenReserver reserver, Object token) {
        return reserver.testToken(placeInstance, token);
    }

    @Override
    protected void unremove(TokenReserver reserver, Object token) {
        reserver.untestToken(placeInstance, token);
    }
}